<?php
    require_once "getcontent.php";
    $GLOBALS["DynPG"]->cacheLiteDisabled = true;

    $GLOBALS["DynPG"]->SetParam_PathToRoot('./');
    $GLOBALS["DynPG"]->setupLanguage($_POST['formlang']);

    // PLEASE SPECIFY PATH FROM THE "__include_REQUESTS"-DIRECTORY
    // AS ROOT !

    // This page would be included when the form is valid.
    $_page_when_valid = "formulars_send.php";

    // Textid of the error-/successfull-Page
    $id_success = @urlencode($_POST["successpge"]);
    $id_error   = @urlencode($_POST["errorpge"]);

    define("C_FORM_TYPE__POST", 1);
    define("C_FORM_TYPE__GET",  2);

    require_once 'formulars_bin.php';

    /* {{{
    *   START function private_Is_array_empty_ref102005($array)
    *   }}}
    */
    /**
    * This function checks if an array has only empty values.
    *
    * @package Valid html-<form>-data throught different routines.
    * @author Daniel Schliebner
    * @param array of variant
    * @return boolean true when array has only empty entries, otherwise false
    */
    function private_Is_array_empty_ref102005($array)
    {
        foreach ( $array as $key=>$value )
        {
            if ( !empty($key) || !empty($value) ) {
                return FALSE;
            }
        }

        return TRUE;
    }
    /* {{{ FINISHED function private_Is_array_empty_ref102005($array) }}} */

    // check if form-object was initalized with method="post" and check if
    // valid.
    if ( !private_Is_array_empty_ref102005($_POST) ) {
        if ( public_Valid_form_data_ref102005(C_FORM_TYPE__POST, $error) ) {
        	// if the user specified a process page, we include it;
        	// this has the advantage, that a user can handle seperate
        	// formular processes, using an own process page
			if (!empty($_POST['processpage']) && preg_match('/^\w+\.\w+$/', $_POST['processpage']) == 1) {
        		if (empty($_POST['processtype']) || (!empty($_POST['processtype']) && $_POST['processtype'] == 'no')) {
        			// include and redirect to the valid-page
					$_SESSION['FORM_DATA'] = $_POST;
					$_SESSION['FORM_DATA']['ERROR'] = false;
            		$_SESSION['FORM_DATA']['ERROR_STRING'] = '';
                    $_SESSION['FORM_DATA']['SUCCESS_STRING'] = $GLOBALS['DynPG']->language[1]->str['lang_forms_success'];
                    $_SESSION['FORM_DATA']['MSG_FORMNAME'] = $_POST['formname'];
					$_SESSION['_VALID_FORM_REF102005_IP'] = ((!getenv("REMOTE_ADDR")) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR"));
					@ob_start();
					@include(dirname(__FILE__) . '/' . $_POST['processpage']);
					@ob_end_clean();
					unset($_SESSION['_VALID_FORM_REF102005_IP']);
				} else {
					// include and do not redirect to the valid-page
					$pp = $_POST['processpage'];
					unset($_POST['processpage']);
					unset($_POST['processtype']);

					if (empty($_SESSION['_VALID_FORM_NAME'])) {
		            	$_SESSION['_VALID_FORM_NAME'] = Array();
		            }

					$_SESSION['FORM_DATA'] = $_POST;
					$_SESSION['FORM_DATA']['ERROR'] = false;
            		$_SESSION['FORM_DATA']['ERROR_STRING'] = '';
                    $_SESSION['FORM_DATA']['SUCCESS_STRING'] = $GLOBALS['DynPG']->language[1]->str['lang_forms_success'];
                    $_SESSION['FORM_DATA']['MSG_FORMNAME'] = $_POST['formname'];
            		$_SESSION['_VALID_FORM_NAME'] []= strtolower($_POST['formname']);
					$_SESSION['_VALID_FORM_REF102005_IP'] = ((!getenv("REMOTE_ADDR")) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR"));
					@include(dirname(__FILE__) . '/' . $pp);
					unset($_SESSION['_VALID_FORM_REF102005_IP']);
					exit;
				}
			}

            $_SESSION['FORM_' . $_POST['formname'] . '_DATA_TIME'] = time();
            $_SESSION['FORM_' . $_POST['formname'] . '_DATA_HASH'] = strtoupper( md5( uniqid( rand() , true ) ) );

            if (empty($_SESSION['_VALID_FORM_NAME'])) {
            	$_SESSION['_VALID_FORM_NAME'] = Array();
            }

			$_SESSION['_VALID_FORM_NAME'] []= strtolower($_POST['formname']);
			$_SESSION['_VALID_FORM_REF102005_IP'] = ((!getenv("REMOTE_ADDR")) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR"));

			unset($_SESSION['FORM_DATA']);
            unset($_SESSION['FORM_'.trim(strtolower($_POST['formname'])).'_DATA']);
			$_SESSION['FORM_DATA']['ERROR'] = false;
            $_SESSION['FORM_DATA']['SUCCESS_STRING'] = $GLOBALS['DynPG']->language[1]->str['lang_forms_success'];
            $_SESSION['FORM_DATA']['MSG_FORMNAME'] = $_POST['formname'];

            include $_page_when_valid;

            if($id_success == 'SELF'){
                $refer_query = '?'.$_POST['querystring'];
            }else{
                $refer_query = $_POST['referquery'].($_POST['referquery']!='?' ? '&' : '')."read_article=$id_success";
            }

            header("Location:" . $_POST['referpath'] . $refer_query);
            exit;
        } else {
            $_SESSION['FORM_DATA'] = $_POST;
            $_SESSION['FORM_DATA']['ERROR'] = true;
            $_SESSION['FORM_DATA']['ERROR_STRING'] = $GLOBALS['DynPG']->language[1]->str['lang_forms_errors_number_' . sprintf("%02d", $error)];
            $_SESSION['FORM_DATA']['MSG_FORMNAME'] = $_POST['formname'];
            
            if($id_error == 'SELF'){
                $refer_query = '?'.$_POST['querystring'];
            }else{
                $refer_query = $_POST['referquery'].($_POST['referquery']!='?' ? '&' : '')."read_article=$id_error";
            }
            
            header("Location:" . $_POST['referpath'] . $refer_query );
            exit;
        }
    }
    exit;
?>